Bug 1134299 - Layout switching happens with unspecified shortcut
Summary: Layout switching happens with unspecified shortcut
Keywords:
Status: NEW
Alias: None
Product: Fedora
Classification: Fedora
Component: gnome-settings-daemon
Version: 29
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Rui Matos
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1626995
TreeView+ depends on / blocked
 
Reported: 2014-08-27 09:17 UTC by Stas Sergeev
Modified: 2018-11-27 22:53 UTC (History)
11 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
: 1626995 (view as bug list)
Environment:
Last Closed: 2016-07-19 12:04:00 UTC


Attachments (Terms of Use)

Description Stas Sergeev 2014-08-27 09:17:02 UTC
Description of problem:
In control center I have only next input
source hotkey Ctrl-Menu and modifier-only
switch RightCtrl-Shift. Everything else
is disabled. Still, RShift-LShift combo
also switches the layouts! (including the
indicator change)
It shouldn't, it is not set anywhere.

Version-Release number of selected component (if applicable):
the one from latest f19 updates

How reproducible:
easily

Steps to Reproduce:
1. Set up layout switch keybindings to not include double-Shift
2. Hit both shifts

Actual results:
Layout switches

Expected results:
Layout should not switch

Additional info:

Comment 1 fujiwara 2014-08-28 02:49:27 UTC
I can reproduce the same problem in Fedora 21 too.

% gsettings get org.gnome.desktop.input-sources xkb-options
['grp:rctrl_rshift_toggle']

Comment 2 Mike FABIAN 2014-08-28 07:02:21 UTC
 I can also reproduce this on f20.

$ gsettings get org.gnome.desktop.input-sources xkb-options
['terminate:ctrl_alt_bksp', '', 'eurosign:5', 'grp:rctrl_rshift_toggle']

I have Super+Space set as the switch to next input source
and (just as the reporter) RightCtrl+RightShift as the modifier only
input source switch.

I can now use *all* of the following key combinations to switch input sources:

RightCtrl+RightShift
LeftCtrl+RightShift
LeftAlt+RightShift
LeftShift+RightShift

Comment 3 Mike FABIAN 2014-08-28 09:36:49 UTC
Rui Matos told me in IRC that this is an X server problem, 
it has nothing to do with Gnome.

Comment 4 Mike FABIAN 2014-08-28 09:40:03 UTC
Rui Matos also told me that LeftAlt+RightShift does not switch
(only the other 3 combinations mentioned in comment#2 switch).

I tried again and Rui is right.

The reason why I thought that LeftAlt+RigthShift does switch input
sources is that switching the input source to “gucharmap”
unexpectedly remapped my keyboard layout (probably to “us”). This
changed the position of the left alt key (My own layout has the left
alt key on the left control key and the left alt key is "Meta" (for
use in Emacs)). Switching to the "gucharmap" input source mapped the
left alt key to its usual position and the left control key became
control again. So it was LeftCtrl+RightShift again doing the input
source switching, *not* LeftAlt+RightShift.

Comment 5 Stas Sergeev 2014-08-28 11:20:04 UTC
(In reply to Mike FABIAN from comment #3)
> Rui Matos told me in IRC that this is an X server problem, 
> it has nothing to do with Gnome.
What does this mean to a poor user?

Comment 6 Rui Matos 2014-08-28 11:25:55 UTC
(In reply to Stas Sergeev from comment #5)
> (In reply to Mike FABIAN from comment #3)
> > Rui Matos told me in IRC that this is an X server problem, 
> > it has nothing to do with Gnome.
> What does this mean to a poor user?

It means that it won't be fixed until we switch to wayland. In any case, this is a fairly low priority bug, there's much bigger fish to fry out there.

Comment 7 Stas Sergeev 2014-08-29 09:44:34 UTC
(In reply to Rui Matos from comment #6)
> It means that it won't be fixed until we switch to wayland. In any case,
> this is a fairly low priority bug
This bugzilla doesn't allow me to change priority for
some reason...
I agree the bug is rather minor, but in pidgin you do
a newline with RShift-Enter, and the new line usually
starts with the capital letter, so LShift gets pressed
as well. So the annoyance factor is non-zero.

Comment 8 Fedora End Of Life 2015-11-04 10:52:47 UTC
This message is a reminder that Fedora 21 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 21. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '21'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 21 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

Comment 9 Fedora End Of Life 2016-07-19 12:04:00 UTC
Fedora 22 changed to end-of-life (EOL) status on 2016-07-19. Fedora 22 is
no longer maintained, which means that it will not receive any further
security or bug fix updates. As a result we are closing this bug.

If you can reproduce this bug against a currently maintained version of
Fedora please feel free to reopen this bug against that version. If you
are unable to reopen this bug, please file a new report against the
current release. If you experience problems, please add a comment to this
bug.

Thank you for reporting this bug and we are sorry it could not be fixed.

Comment 10 Fedora End Of Life 2017-07-25 18:42:17 UTC
This message is a reminder that Fedora 24 is nearing its end of life.
Approximately 2 (two) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 24. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '24'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 24 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 11 Fedora End Of Life 2017-11-16 19:36:00 UTC
This message is a reminder that Fedora 25 is nearing its end of life.
Approximately 4 (four) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 25. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '25'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 25 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.

Comment 12 fujiwara 2017-11-17 08:30:09 UTC
I guess this problem happens in GNOME Wayland too because both X11 and Wayland use the same mutter logic.

Comment 13 Olivier Fourdan 2017-11-17 09:40:07 UTC
(In reply to fujiwara from comment #12)
> I guess this problem happens in GNOME Wayland too because both X11 and
> Wayland use the same mutter logic.

I think you're right, mutter doesn't distinguish between left/right modifiers in its keybindings code:

https://git.gnome.org/browse/mutter/tree/src/core/keybindings.c#n490

 491   else if (g_str_equal (iso_next_group_option, "ctrl_shift_toggle") ||
 492            g_str_equal (iso_next_group_option, "lctrl_lshift_toggle") ||
 493            g_str_equal (iso_next_group_option, "rctrl_rshift_toggle"))
 494     {
 495       resolved_key_combo_copy (&keys->iso_next_group_combo[0],
 496                                &keys->iso_next_group_combo[1]);
 497 
 498       keys->iso_next_group_combo[0].mask = ShiftMask;
 499       keys->iso_next_group_combo[1].mask = ControlMask;
 500       keys->n_iso_next_group_combos = 2;
 501     }

[...]

 511   else if (g_str_equal (iso_next_group_option, "alt_shift_toggle") ||
 512            g_str_equal (iso_next_group_option, "lalt_lshift_toggle"))
 513     {
 514       resolved_key_combo_copy (&keys->iso_next_group_combo[0],
 515                                &keys->iso_next_group_combo[1]);
 516 
 517       keys->iso_next_group_combo[0].mask = Mod1Mask;
 518       keys->iso_next_group_combo[1].mask = ShiftMask;
 519       keys->n_iso_next_group_combos = 2;
 520     }

So basically, it just checks for the modifier mask (which is not different for left and right)

Comment 14 Jens Petersen 2018-01-03 07:03:54 UTC
Is there an upstream bug for this?

Comment 15 Jens Petersen 2018-01-03 07:04:54 UTC
Still happens with F27+ presumably?

Comment 16 Stas Sergeev 2018-01-03 21:07:55 UTC
(In reply to Jens Petersen from comment #14)
> Is there an upstream bug for this?

True.

Comment 17 Stas Sergeev 2018-01-03 21:08:32 UTC
(In reply to Jens Petersen from comment #15)
> Still happens with F27+ presumably?

True.

Comment 18 Stas Sergeev 2018-01-03 21:09:42 UTC
>> Is there an upstream bug for this?
> True.

Sorry, ignore this, meant to answer to comment #15.

Comment 20 Ben Cotton 2018-11-27 14:41:28 UTC
This message is a reminder that Fedora 27 is nearing its end of life.
On 2018-Nov-30  Fedora will stop maintaining and issuing updates for
Fedora 27. It is Fedora's policy to close all bug reports from releases
that are no longer maintained. At that time this bug will be closed as
EOL if it remains open with a Fedora  'version' of '27'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version' 
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not 
able to fix it before Fedora 27 is end of life. If you would still like 
to see this bug fixed and are able to reproduce it against a later version 
of Fedora, you are encouraged  change the 'version' to a later Fedora 
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events. Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.


Note You need to log in before you can comment on or make changes to this bug.